diff --git a/backup/util/helper/restore_decode_content.class.php b/backup/util/helper/restore_decode_content.class.php
index 9b1e091..6cc0312 100644
--- a/backup/util/helper/restore_decode_content.class.php
+++ b/backup/util/helper/restore_decode_content.class.php
@@ -92,15 +92,28 @@ class restore_decode_content implements processable {
     protected function get_iterator() {
         global $DB;
 
+        $cache = backup_muc_manager::get('' . $this->mapping);
+        $cache_ids = $cache->get_store()->find_all();
+
+        if (empty($cache_ids)) {
+            $sql = " < 0";
+            $params = array();
+        } else {
+            $newitemids = array();
+            foreach ($cache_ids as $cache_id) {
+                $data = $cache->get($cache_id);
+                $newitemids[$data['newitemid']] = $data['newitemid'];
+            }
+
+            list($sql, $params) = $DB->get_in_or_equal($newitemids);
+        }
+
         // Build the SQL dynamically here
         $fieldslist = 't.' . implode(', t.', $this->fields);
         $sql = "SELECT t.id, $fieldslist
                   FROM {" . $this->tablename . "} t
-                  JOIN {backup_ids_temp} b ON b.newitemid = t.id
-                 WHERE b.backupid = ?
-                   AND b.itemname = ?";
-        $params = array($this->restoreid, $this->mapping);
-        return ($DB->get_recordset_sql($sql, $params));
+                 WHERE t.id $sql";
+        return $DB->get_recordset_sql($sql, $params);
     }
 
     protected function update_iterator_row($row) {
diff --git a/backup/util/helper/restore_prechecks_helper.class.php b/backup/util/helper/restore_prechecks_helper.class.php
index a80a80b..384908d 100644
--- a/backup/util/helper/restore_prechecks_helper.class.php
+++ b/backup/util/helper/restore_prechecks_helper.class.php
@@ -36,7 +36,7 @@
  *
  * TODO: Finish phpdocs
  */
-abstract class restore_prechecks_helper {
+class restore_prechecks_helper {
 
     /**
      * Entry point for all the prechecks to be performed before restore
diff --git a/backup/util/includes/backup_includes.php b/backup/util/includes/backup_includes.php
index 653556f..149c8bd 100644
--- a/backup/util/includes/backup_includes.php
+++ b/backup/util/includes/backup_includes.php
@@ -60,6 +60,7 @@ require_once($CFG->dirroot . '/backup/util/helper/backup_null_iterator.class.php
 require_once($CFG->dirroot . '/backup/util/helper/backup_array_iterator.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/backup_anonymizer_helper.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/backup_file_manager.class.php');
+require_once($CFG->dirroot . '/backup/util/helper/muc_helper.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/restore_moodlexml_parser_processor.class.php'); // Required by backup_general_helper::get_backup_information().
 require_once($CFG->dirroot . '/backup/util/xml/xml_writer.class.php');
 require_once($CFG->dirroot . '/backup/util/xml/output/xml_output.class.php');
diff --git a/backup/util/includes/restore_includes.php b/backup/util/includes/restore_includes.php
index 70ec44e..df9cb2a 100644
--- a/backup/util/includes/restore_includes.php
+++ b/backup/util/includes/restore_includes.php
@@ -36,6 +36,7 @@ require_once($CFG->dirroot . '/backup/backup.class.php');
 require_once($CFG->dirroot . '/backup/util/structure/restore_path_element.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/backup_anonymizer_helper.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/backup_file_manager.class.php');
+require_once($CFG->dirroot . '/backup/util/helper/muc_helper.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/restore_prechecks_helper.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/restore_moodlexml_parser_processor.class.php');
 require_once($CFG->dirroot . '/backup/util/helper/restore_inforef_parser_processor.class.php');
diff --git a/backup/util/plan/restore_structure_step.class.php b/backup/util/plan/restore_structure_step.class.php
index 94e5ad6..fc9bcbd 100644
--- a/backup/util/plan/restore_structure_step.class.php
+++ b/backup/util/plan/restore_structure_step.class.php
@@ -159,7 +159,7 @@ abstract class restore_structure_step extends restore_step {
      * To send ids pairs to backup_ids_table and to store them into paths
      *
      * This method will send the given itemname and old/new ids to the
-     * backup_ids_temp table, and, at the same time, will save the new id
+     * backup ids cache, and, at the same time, will save the new id
      * into the corresponding restore_path_element for easier access
      * by children. Also will inject the known old context id for the task
      * in case it's going to be used for restoring files later
diff --git a/backup/util/structure/backup_nested_element.class.php b/backup/util/structure/backup_nested_element.class.php
index 32abd9a..a643781 100644
--- a/backup/util/structure/backup_nested_element.class.php
+++ b/backup/util/structure/backup_nested_element.class.php
@@ -33,6 +33,7 @@ class backup_nested_element extends base_nested_element implements processable {
     protected $table;     // Table (without prefix) to fetch records from
     protected $tablesortby; // The field to sort by when using the table methods
     protected $sql;       // Raw SQL to fetch records from
+    protected $sql2;       // Raw SQL to fetch records from
     protected $params;    // Unprocessed params as specified in the set_source() call
     protected $procparams;// Processed (path resolved) params array
     protected $aliases;   // Define DB->final element aliases
@@ -40,6 +41,9 @@ class backup_nested_element extends base_nested_element implements processable {
     protected $counter;   // Number of instances of this element that have been processed
     protected $results;  // Logs the results we encounter during the process.
     protected $logs;     // Some log messages that could be retrieved later.
+    protected $sqlparambackupid; // The backupid to use in finding the cache. Not called backupid because clashes with file_nested_element field
+    protected $cachename; // The name of the backup ids cache used for the query
+    protected $cachematchfield; // The field in the cache object that provides values to match
 
     /**
      * Constructor - instantiates one backup_nested_element, specifying its basic info.
@@ -54,13 +58,18 @@ class backup_nested_element extends base_nested_element implements processable {
         $this->table     = null;
         $this->tablesortby = null;
         $this->sql       = null;
+        $this->sql2      = null;
         $this->params    = null;
         $this->procparams= null;
+        $this->procparams2   = null;
         $this->aliases   = array();
         $this->fileannotations = array();
         $this->counter   = 0;
         $this->results  = array();
         $this->logs     = array();
+        $this->cachename = null;
+        $this->cachematchfield = null;
+        $this->sqlparambackupid = null;
     }
 
     /**
@@ -214,6 +223,24 @@ class backup_nested_element extends base_nested_element implements processable {
         $this->procparams = $this->convert_sql_params($params);
     }
 
+    public function set_source_sql_using_backup_ids($sql, $params, $bid, $cachename, $matchfield) {
+
+        if (!is_array($params)) { // Check we are passing array
+            throw new base_element_struct_exception('setsourcerequiresarrayofparams');
+        }
+        // TODO: Only elements having final elements can set source
+        $this->sql2 = $sql;
+        $this->procparams2 = $this->convert_sql_params($params);
+
+        $this->sqlparambackupid = $bid;
+        $this->cachename = $cachename;
+        $this->cachematchfield = $matchfield;
+    }
+
+    public function set_source_cache($cachename) {
+        $this->cachename = $cachename;
+    }
+
     public function set_source_alias($dbname, $finalelementname) {
         // Get final element
         $finalelement = $this->get_final_element($finalelementname);
@@ -272,10 +299,52 @@ class backup_nested_element extends base_nested_element implements processable {
         return $this->sql;
     }
 
+    public function get_source_sql_using_backup_ids($params) {
+        global $DB;
+
+        /* A cache source will have sqlparambackupid and cachename set but not cachematchfield */
+        if (!$this->cachematchfield) {
+            return null;
+        }
+
+        $cache = backup_muc_manager::get('' . $this->cachename);
+        $cache_content = $cache->get_store()->find_all();
+
+        if (empty($cache_content)) {
+            // No data to match => Empty result set.
+            return array(NULL, NULL);
+        } else {
+            if (is_object($cache_content[0])) {
+                $ids = array_map(function($item) { return $item->{$this->cachematchfield}; }, $cache_content);
+            } else {
+                $ids = array_values($cache_content);
+            }
+            list($sql, $sql_params) = $DB->get_in_or_equal($ids);
+        }
+        $sql = str_replace('*SQL*', $sql, $this->sql2);
+        $params = array_merge($this->procparams2, $sql_params);
+        return array($sql, $params);
+    }
+
     public function get_counter() {
         return $this->counter;
     }
 
+    public function get_source_cache() {
+        if (!$this->cachename || !is_null($this->sql2)) {
+            return null;
+        }
+
+        $cache = backup_muc_manager::get('' . $this->cachename);
+        $cache_content = $cache->get_store()->find_all();
+        if (is_object($cache_content[0])) {
+            return $cache_content;
+        } else {
+            sort ($cache_content);
+            return array_map(function ($id) { $temp = new StdClass(); $temp->id = $id; return $temp; }, $cache_content);
+        }
+    }
+
     /**
      * Simple filler that, matching by name, will fill both attributes and final elements
      * depending of this nested element, debugging info about non-matching elements and/or
diff --git a/backup/util/structure/tests/structure_test.php b/backup/util/structure/tests/structure_test.php
index c8870cc..6eee986 100644
--- a/backup/util/structure/tests/structure_test.php
+++ b/backup/util/structure/tests/structure_test.php
@@ -280,7 +280,7 @@ class backup_structure_testcase extends advanced_testcase {
         $rating->annotate_ids('user2', 'userid');
         $rating->annotate_ids('forum_post', 'itemid');
 
-        // Create the backup_ids_temp table
+        // Create the backup ids cache
         backup_controller_dbops::create_backup_ids_temp_table($backupid);
 
         // Instantiate in memory xml output
@@ -418,26 +418,28 @@ class backup_structure_testcase extends advanced_testcase {
         $c_dissuserid = $DB->count_records_sql('SELECT COUNT(DISTINCT userid) FROM {forum_discussions}');
         $c_ratuserid  = $DB->count_records_sql('SELECT COUNT(DISTINCT userid) FROM {rating}');
         // Count records in backup_ids_table
-        $f_forumpost = $DB->count_records('backup_ids_temp', array('backupid' => $backupid, 'itemname' => 'forum_post'));
-        $f_user1     = $DB->count_records('backup_ids_temp', array('backupid' => $backupid, 'itemname' => 'user1'));
-        $f_user2     = $DB->count_records('backup_ids_temp', array('backupid' => $backupid, 'itemname' => 'user2'));
-        $c_notbackupid = $DB->count_records_select('backup_ids_temp', 'backupid != ?', array($backupid));
+        $cache = backup_muc_manager::get('forum_post');
+        $f_forumpost = sizeof($cache->get_store()->find_all());
+        $cache = backup_muc_manager::get('user1');
+        $f_user1 = sizeof($cache->get_store()->find_all());
+        $cache = backup_muc_manager::get('user2');
+        $f_user2 = sizeof($cache->get_store()->find_all());
         // Peform tests by comparing counts
-        $this->assertEquals($c_notbackupid, 0); // there isn't any record with incorrect backupid
         $this->assertEquals($c_postsid, $f_forumpost); // All posts have been registered
         $this->assertEquals($c_dissuserid, $f_user1); // All users coming from discussions have been registered
         $this->assertEquals($c_ratuserid, $f_user2); // All users coming from ratings have been registered
 
         // Check file annotations against DB
-        $fannotations = $DB->get_records('backup_ids_temp', array('backupid' => $backupid, 'itemname' => 'file'));
+        $cache = backup_muc_manager::get('file');
+        $fannotations = $cache->get_store()->find_all();
         $ffiles       = $DB->get_records('files', array('contextid' => $this->contextid));
         $this->assertEquals(count($fannotations), count($ffiles)); // Same number of recs in both (all files have been annotated)
         foreach ($fannotations as $annotation) { // Check ids annotated
             $this->assertTrue($DB->record_exists('files', array('id' => $annotation->itemid)));
         }
 
-        // Drop the backup_ids_temp table
-        backup_controller_dbops::drop_backup_ids_temp_table('testingid');
+        // Drop the backup ids cache
+        backup_controller_dbops::purge_backup_ids_temp_cache('testingid');
     }
 
     /**
diff --git a/backup/util/xml/parser/processors/grouped_parser_processor.class.php b/backup/util/xml/parser/processors/grouped_parser_processor.class.php
index 748daac..4a195ec 100644
--- a/backup/util/xml/parser/processors/grouped_parser_processor.class.php
+++ b/backup/util/xml/parser/processors/grouped_parser_processor.class.php
@@ -162,14 +162,23 @@ abstract class grouped_parser_processor extends simplified_parser_processor {
      * false if not
      */
     protected function grouped_parent_exists($path) {
+        static $last_path, $last_result;
+
+        if ($path == $last_path) {
+            return $last_result;
+        }
+
+        $last_path = $path;
         $parentpath = $this->get_parent_path($path);
 
         while ($parentpath != '/') {
             if ($this->path_is_grouped($parentpath)) {
+                $last_result = $parentpath;
                 return $parentpath;
             }
             $parentpath = $this->get_parent_path($parentpath);
         }
+        $last_result = false;
         return false;
     }
 
diff --git a/backup/util/xml/parser/progressive_parser.class.php b/backup/util/xml/parser/progressive_parser.class.php
index a5ebc4d..90ebeb1 100644
--- a/backup/util/xml/parser/progressive_parser.class.php
+++ b/backup/util/xml/parser/progressive_parser.class.php
@@ -153,11 +153,23 @@ class progressive_parser {
             throw new progressive_parser_exception('progressive_parser_already_used');
         }
         if ($this->file) {
+            $blocks = (int) ((filesize($this->file) + 8191) / 8192);
+            if ($this->progress) {
+                $this->progress->start_progress('Loading XML file', $blocks);
+            }
+            $block_num = 0;
             $fh = fopen($this->file, 'r');
             while ($buffer = fread($fh, 8192)) {
                 $this->parse($buffer, feof($fh));
+                $block_num++;
+                if ($this->progress && !($block_num % 50)) {
+                    $this->progress->progress($block_num);
+                }
             }
             fclose($fh);
+            if ($this->progress) {
+                $this->progress->end_progress();
+            }
         } else {
             $this->parse($this->contents, true);
         }
@@ -188,7 +200,7 @@ class progressive_parser {
 
     protected function publish($data) {
         $this->processor->receive_chunk($data);
-        if (!empty($this->progress)) {
+        if (FALSE && !empty($this->progress)) {
             // Report indeterminate progress.
             $this->progress->progress();
         }
diff --git a/blocks/html/backup/moodle2/restore_html_block_task.class.php b/blocks/html/backup/moodle2/restore_html_block_task.class.php
index c3ce29b..bc358ef 100644
--- a/blocks/html/backup/moodle2/restore_html_block_task.class.php
+++ b/blocks/html/backup/moodle2/restore_html_block_task.class.php
@@ -71,14 +71,35 @@ class restore_html_block_decode_content extends restore_decode_content {
 
         // Build the SQL dynamically here
         $fieldslist = 't.' . implode(', t.', $this->fields);
+        $cache = backup_muc_manager::get($this->mapping);
+        $cache_ids = $cache->get_store()->find_all();
+
+        if (empty($cache_ids)) {
+            $sql = "< 0";
+            $params = array();
+        } else {
+            $newitemids = array();
+            foreach($cache_ids as $id) {
+                $data = $cache->get($id);
+                $newitemids[$data['newitemid']] = $data['newitemid'];
+            }
+            list($sql, $params) = $DB->get_in_or_equal($newitemids);
+        }
+
         $sql = "SELECT t.id, $fieldslist
-                  FROM {" . $this->tablename . "} t
-                  JOIN {backup_ids_temp} b ON b.newitemid = t.id
-                 WHERE b.backupid = ?
-                   AND b.itemname = ?
-                   AND t.blockname = 'html'";
-        $params = array($this->restoreid, $this->mapping);
-        return ($DB->get_recordset_sql($sql, $params));
+            FROM {" . $this->tablename . "} t
+            WHERE t.blockname = 'html'
+            AND t.id $sql";
+        $result2_rs = ($DB->get_recordset_sql($sql, $params));
+
+        $result2 = array();
+        foreach($result2_rs as $result) {
+            $result2[] = $result;
+        }
+        $result2_rs->close();
+
+        $result2_rs = ($DB->get_recordset_sql($sql, $params));
+        return $result2_rs;
     }
 
     protected function preprocess_field($field) {
diff --git a/cache/classes/helper.php b/cache/classes/helper.php
index 4f0586b..35628523 100644
--- a/cache/classes/helper.php
+++ b/cache/classes/helper.php
@@ -526,11 +526,15 @@ class cache_helper {
      */
     public static function hash_key($key, cache_definition $definition) {
         if ($definition->uses_simple_keys()) {
-            if (debugging() && preg_match('#[^a-zA-Z0-9_]#', $key)) {
+            if (preg_match('#[^a-zA-Z0-9_]#', $key) && debugging()) {
                 throw new coding_exception('Cache definition '.$definition->get_id().' requires simple keys. Invalid key provided.', $key);
             }
             // We put the key first so that we can be sure the start of the key changes.
-            return (string)$key . '-' . $definition->generate_single_key_prefix();
+            if (strlen((string) $key) <= 32) {
+                return (string) $key;
+            } else {
+                return (string)$key . '-' . $definition->generate_single_key_prefix();
+            }
         }
         $key = $definition->generate_single_key_prefix() . '-' . $key;
         return sha1($key);
diff --git a/cache/classes/loaders.php b/cache/classes/loaders.php
index 6cd588a..f424858 100644
--- a/cache/classes/loaders.php
+++ b/cache/classes/loaders.php
@@ -885,7 +885,7 @@ class cache implements cache_loader {
      *
      * @return cache_store
      */
-    protected function get_store() {
+    public function get_store() {
         return $this->store;
     }
 
diff --git a/cache/tests/cache_test.php b/cache/tests/cache_test.php
index 5a85f14..4507cda 100644
--- a/cache/tests/cache_test.php
+++ b/cache/tests/cache_test.php
@@ -893,8 +893,7 @@ class core_cache_testcase extends advanced_testcase {
 
         // OK data added, data invalidated, and invalidation time has been set.
         // Now we need to manually add back the data and adjust the invalidation time.
-        $hash = md5(cache_store::MODE_APPLICATION.'/phpunit/eventinvalidationtest/'.$CFG->wwwroot.'phpunit');
-        $timefile = $CFG->dataroot."/cache/cachestore_file/default_application/phpunit_eventinvalidationtest/las-cache/lastinvalidation-$hash.cache";
+        $timefile = $CFG->dataroot."/cache/cachestore_file/default_application/phpunit_eventinvalidationtest/las-cache/lastinvalidation.cache";
         // Make sure the file is correct.
         $this->assertTrue(file_exists($timefile));
         $timecont = serialize(cache::now() - 60); // Back 60sec in the past to force it to re-invalidate.
@@ -902,7 +901,7 @@ class core_cache_testcase extends advanced_testcase {
         file_put_contents($timefile, $timecont);
         $this->assertTrue(file_exists($timefile));
 
-        $datafile = $CFG->dataroot."/cache/cachestore_file/default_application/phpunit_eventinvalidationtest/tes-cache/testkey1-$hash.cache";
+        $datafile = $CFG->dataroot."/cache/cachestore_file/default_application/phpunit_eventinvalidationtest/tes-cache/testkey1.cache";
         $datacont = serialize("test data 1");
         make_writable_directory(dirname($datafile));
         file_put_contents($datafile, $datacont);
diff --git a/local/automatedemails b/local/automatedemails
index 1e61526..49b4a1a 160000
--- a/local/automatedemails
+++ b/local/automatedemails
@@ -1 +1 @@
-Subproject commit 1e61526218e8de7588234703db9432e8d7529ed5
+Subproject commit 49b4a1abf96a24a7d72e0820b19ce2bbad6aa4c9
diff --git a/question/type/multianswer/backup/moodle2/restore_qtype_multianswer_plugin.class.php b/question/type/multianswer/backup/moodle2/restore_qtype_multianswer_plugin.class.php
index b8daa03..f6a29af 100644
--- a/question/type/multianswer/backup/moodle2/restore_qtype_multianswer_plugin.class.php
+++ b/question/type/multianswer/backup/moodle2/restore_qtype_multianswer_plugin.class.php
@@ -94,13 +94,26 @@ class restore_qtype_multianswer_plugin extends restore_qtype_plugin {
         global $DB;
         // Now that all the questions have been restored, let's process
         // the created question_multianswer sequences (list of question ids).
+        $id_cache = backup_muc_manager::get('question_created');
+        $cache_items = $id_cache->get_store()->find_all();
+
+        if (empty($cache_items)) {
+            return;
+        }
+
+        $newitemids = array();
+        foreach($cache_items as $item_id) {
+            $record = $id_cache->get($item_id);
+            $newitemids[] = $record['newitemid'];
+        }
+
+        list($sql, $params) = $DB->get_in_or_equal($newitemids);
         $rs = $DB->get_recordset_sql("
                 SELECT qma.id, qma.sequence
-                  FROM {question_multianswer} qma
-                  JOIN {backup_ids_temp} bi ON bi.newitemid = qma.question
-                 WHERE bi.backupid = ?
-                   AND bi.itemname = 'question_created'",
-                array($this->get_restoreid()));
+                FROM {question_multianswer} qma
+                WHERE qma.question $sql",
+                $params);
+
         foreach ($rs as $rec) {
             $sequencearr = explode(',', $rec->sequence);
             foreach ($sequencearr as $key => $question) {
diff --git a/question/type/random/backup/moodle2/restore_qtype_random_plugin.class.php b/question/type/random/backup/moodle2/restore_qtype_random_plugin.class.php
index 633d298..d6e775e 100644
--- a/question/type/random/backup/moodle2/restore_qtype_random_plugin.class.php
+++ b/question/type/random/backup/moodle2/restore_qtype_random_plugin.class.php
@@ -104,15 +104,28 @@ class restore_qtype_random_plugin extends restore_qtype_plugin {
         global $DB;
 
         // Update any blank random questiontexts to 0.
+        $id_cache = backup_muc_manager::get('question_created');
+        $cache_items = $id_cache->get_store()->find_all();
+
+        if (empty($cache_items)) {
+            return;
+        }
+
+        $newitemids = array();
+        foreach($cache_items as $item) {
+            $data = $id_cache->get($item);
+            $newitemids[$data['newitemid']] = $data['newitemid'];
+        }
+
+        list($in_sql, $params) = $DB->get_in_or_equal($newitemids);
+        $params[] = '';
+
         $sql = "UPDATE {question}
                    SET questiontext = '0'
                  WHERE qtype = 'random'
-                   AND " . $DB->sql_compare_text('questiontext') . " = ?
-                   AND id IN (SELECT bi.newitemid
-                                FROM {backup_ids_temp} bi
-                               WHERE bi.backupid = ?
-                                 AND bi.itemname = 'question_created')";
+                   AND id $in_sql
+                   AND " . $DB->sql_compare_text('questiontext') . " = ?";
 
-        $DB->execute($sql, array('', $this->get_restoreid()));
+        $DB->execute($sql, $params);
     }
 }
-- 
2.3.5

